#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "starmapstar4xi.py">
#<abstract4xi abstract = "provides function starmapstar4xi"/>
#<refer4xi reference = "pool.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'starmapstar4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import time     
except:
    pass
try:                 # rare ones
    import queue
    import itertools
    import collections          
except:
    pass 
try:                 # imported-as ones 
    pass        
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                           
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.pool import starmapstar
except:
    print("starmapstar4xi.py *** failed in from multiprocessing.pool import starmapstar ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#"
#/>




# -------------------------------------------------------------------------------------------------
#<function4xi function = "starmapstar4xi" usage = "
#   pool.py:
#       Pool
#           starmap
#               return self._map_async(func, iterable, starmapstar, chunksize).get()               
#
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def starmapstar4xi(args):
    '''
    task queue mapping
    '''
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------        
    class2print = "starmapstar4xi"
    method2print = "starmapstar4xi"

    message2print = "{started" + "; starmapstar4xi-started: " + str(starmapstar4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{passed" + "; args-passed-to-starmapstar4xi: " + str(args) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
   
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------        
                      
    message2print = "{returning" + "; list-returning-by-starmapstar4xi: " + str((itertools.starmap(args[0], args[1]))) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
    return list(itertools.starmap(args[0], args[1]))

#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of starmapstar4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
 